/**********************************************

	Prototypes for Keyb.c

**********************************************/

#include "global.h"

#ifndef __Keyb_H
#define __Keyb_H


/**********************************************

	Prototypes

**********************************************/

extern UBYTE K_KbHit(void);
extern void K_EatKbHit(void);
extern UBYTE K_StoreKbHit(UWORD KEY);
extern UWORD K_KeyPress(void);


/**********************************************

	#define - KeyPress

**********************************************/

#define KP_UP			0x48e0
#define KP_DOWN		0x50e0
#define KP_LEFT		0x4be0
#define KP_RIGHT		0x4de0
#define KP_PGUP		0x49e0
#define KP_PGDOWN		0x51e0
#define KP_INS			0x52e0
#define KP_DEL			0x53e0
#define KP_HOME		0x47e0
#define KP_END			0x4fe0
#define KP_ESC			0x011b
#define KP_BS			0x0e08
#define KP_TAB			0x0f09
#define KP_ENTER		0x1c0d
#define KP_F1			0x3b00
#define KP_F2			0x3c00
#define KP_F3			0x3d00
#define KP_F4			0x3e00
#define KP_F5			0x3f00
#define KP_F6			0x4000
#define KP_F7			0x4100
#define KP_F8			0x4200
#define KP_F9			0x4300
#define KP_F10			0x4400
#define KP_F11			0x8500
#define KP_F12			0x8600

#define KP_S_TAB		0x0f00
#define KP_S_F1		0x5400
#define KP_S_F2		0x5500
#define KP_S_F3		0x5600
#define KP_S_F4		0x5700
#define KP_S_F5		0x5800
#define KP_S_F6		0x5900
#define KP_S_F7		0x5a00
#define KP_S_F8		0x5b00
#define KP_S_F9		0x5c00
#define KP_S_F10		0x5d00
#define KP_S_F11		0x8700
#define KP_S_F12		0x8800

#define KP_C_BREAK	0x0000
#define KP_C_UP		0x8de0
#define KP_C_DOWN		0x91e0
#define KP_C_LEFT		0x73e0
#define KP_C_RIGHT	0x74e0
#define KP_C_PGUP		0x84e0
#define KP_C_PGDOWN	0x76e0
#define KP_C_INS		0x92e0
#define KP_C_DEL		0x93e0
#define KP_C_HOME		0x77e0
#define KP_C_END		0x75e0
#define KP_C_BS		0x0e7f
#define KP_C_TAB		0x9400
#define KP_C_ENTER	0x1c0a
#define KP_C_F1		0x5e00
#define KP_C_F2		0x5f00
#define KP_C_F3		0x6000
#define KP_C_F4		0x6100
#define KP_C_F5		0x6200
#define KP_C_F6		0x6300
#define KP_C_F7		0x6400
#define KP_C_F8		0x6500
#define KP_C_F9		0x6600
#define KP_C_F10		0x6700
#define KP_C_F11		0x8900
#define KP_C_F12		0x8a00

#define KP_A_UP		0x9800
#define KP_A_DOWN		0xa000
#define KP_A_LEFT		0x9b00
#define KP_A_RIGHT	0x9d00
#define KP_A_PGUP		0x9900
#define KP_A_PGDOWN	0xa100
#define KP_A_INS		0xa200
#define KP_A_DEL		0xa300
#define KP_A_HOME		0x9700
#define KP_A_END		0x9f00
#define KP_A_ESC		0x0100
#define KP_A_BS		0x0e00
#define KP_A_TAB		0xa500
#define KP_A_ENTER	0x1c00
#define KP_A_F1		0x6800
#define KP_A_F2		0x6900
#define KP_A_F3		0x6a00
#define KP_A_F4		0x6b00
#define KP_A_F5		0x6c00
#define KP_A_F6		0x6d00
#define KP_A_F7		0x6e00
#define KP_A_F8		0x6f00
#define KP_A_F9		0x7000
#define KP_A_F10		0x7100
#define KP_A_F11		0x8b00
#define KP_A_F12		0x8c00
#define KP_A_0			0x8100
#define KP_A_1			0x7800
#define KP_A_2			0x7900
#define KP_A_3			0x7a00
#define KP_A_4			0x7b00
#define KP_A_5			0x7c00
#define KP_A_6			0x7d00
#define KP_A_7			0x7e00
#define KP_A_8			0x7f00
#define KP_A_9			0x8000
#define KP_A_A			0x1e00
#define KP_A_B			0x3000
#define KP_A_C			0x2e00
#define KP_A_D			0x2000
#define KP_A_E			0x1200
#define KP_A_F			0x2100
#define KP_A_G			0x2200
#define KP_A_H			0x2300
#define KP_A_I			0x1700
#define KP_A_J			0x2400
#define KP_A_K			0x2500
#define KP_A_L			0x2600
#define KP_A_M			0x3200
#define KP_A_N			0x3100
#define KP_A_O			0x1800
#define KP_A_P			0x1900
#define KP_A_Q			0x1000
#define KP_A_R			0x1300
#define KP_A_S			0x1f00
#define KP_A_T			0x1400
#define KP_A_U			0x1600
#define KP_A_V			0x2f00
#define KP_A_W			0x1100
#define KP_A_X			0x2d00
#define KP_A_Y			0x1500
#define KP_A_Z			0x2c00

#endif
